"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const fs = __importStar(require("fs/promises"));
const seed_1 = __importDefault(require("./seed"));
globals_1.jest.mock('fs/promises', () => ({
    readdir: globals_1.jest.fn(),
    readFile: globals_1.jest.fn(),
    writeFile: globals_1.jest.fn(),
}));
describe.only('seed', () => {
    beforeEach(() => {
        globals_1.jest.resetAllMocks();
    });
    it('should group the files according to topics in categories.json', async () => {
        const readdirMock = fs.readdir;
        const readFileMock = fs.readFile;
        const writeFileMock = fs.writeFile;
        const metadata = [
            {
                title: 'Problem 1',
                topics: [
                    'Topic 1',
                    'Topic 2',
                ],
            },
            {
                title: 'Problem 2',
                topics: [
                    'Topic 2',
                    'Topic 3',
                    'Topic 4',
                ],
            },
            {
                title: 'Problem 3',
                topics: [
                    'Topic 3',
                    'Topic 5',
                ],
            },
        ];
        const expectedResult = {
            'Topic 1': ['Problem 1'],
            'Topic 2': ['Problem 1', 'Problem 2'],
            'Topic 3': ['Problem 2', 'Problem 3'],
            'Topic 4': ['Problem 2'],
            'Topic 5': ['Problem 3'],
        };
        readdirMock.mockResolvedValue(['file1.json', 'file2.json', 'file3.json']);
        readFileMock.mockResolvedValueOnce(JSON.stringify(metadata[0]));
        readFileMock.mockResolvedValueOnce(JSON.stringify(metadata[1]));
        readFileMock.mockResolvedValueOnce(JSON.stringify(metadata[2]));
        writeFileMock.mockResolvedValue(undefined);
        await (0, seed_1.default)();
        expect(readFileMock).toHaveBeenCalledTimes(3);
        expect(writeFileMock.mock.calls[0][1]).toBe(JSON.stringify(expectedResult, undefined, 2));
    });
    it('should handle errors', async () => {
        const consoleErrorMock = globals_1.jest.spyOn(console, 'error');
        const readdirMock = globals_1.jest.spyOn(fs, 'readdir');
        readdirMock.mockRejectedValue(new Error('Failed to read directory'));
        consoleErrorMock.mockImplementation(() => ({}));
        await (0, seed_1.default)();
        expect(consoleErrorMock).toHaveBeenCalledWith(new Error('Failed to read directory'));
    });
});
