#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirerWrapper_js_1 = __importDefault(require("./utils/inquirerWrapper.js"));
const printWelcome_js_1 = __importDefault(require("./printWelcome.js"));
const problemPrompt_js_1 = __importDefault(require("./problemPrompt.js"));
(async () => {
    process.on('exit', () => console.log('Bye!'));
    (0, printWelcome_js_1.default)();
    try {
        const { action } = await (0, inquirerWrapper_js_1.default)([
            {
                type: 'list',
                name: 'action',
                message: 'What do you want to do?',
                choices: ['continue', 'exit'],
            },
        ]);
        if (action === 'exit') {
            process.exit(0);
        }
        console.clear();
        await (0, problemPrompt_js_1.default)();
    }
    catch (error) {
        console.error(error);
        process.exit(1);
    }
})();
